/******************************************************************************
*
* 
* 
*
******************************************************************************/

/*****************************************************************************
*
* @file te_fsbl_hooks.c
*
*
******************************************************************************/


#include "fsbl.h"
#include "xstatus.h"
//rename to correct board name
#include "te_fsbl_hooks_te0722.h"

/************************** Variable Definitions *****************************/


/************************** Function Prototypes ******************************/


/******************************************************************************
* This function is the hook which will be called  before the bitstream download.
* The user can add all the customized code required to be executed before the
* bitstream download to this routine.
*
* @param None
*
* @return
*		- XST_SUCCESS to indicate success
*		- XST_FAILURE.to indicate failure
*
****************************************************************************/
u32 TE_FsblHookBeforeBitstreamDload_Custom(void)
{
	u32 Status;

	Status = XST_SUCCESS;

  
    xil_printf("\r\n--------------------------------------------------------------------------------\r\n");
    xil_printf("TE0722 TE_FsblHookBeforeBitstreamDload_Custom\r\n"); 
	/* Add the code here */


    xil_printf("\r\n--------------------------------------------------------------------------------\r\n");

	return (Status);
}

/******************************************************************************
* This function is the hook which will be called  after the bitstream download.
* The user can add all the customized code required to be executed after the
* bitstream download to this routine.
*
* @param None
*
* @return
*		- XST_SUCCESS to indicate success
*		- XST_FAILURE.to indicate failure
*
****************************************************************************/
u32 TE_FsblHookAfterBitstreamDload_Custom(void)
{
	u32 Status;

	Status = XST_SUCCESS;

    xil_printf("\r\n--------------------------------------------------------------------------------\r\n");
    xil_printf("TE0722 TE_FsblHookAfterBitstreamDload_Custom\r\n"); 
	/* Add the code here */
    xil_printf("\r\n--------------------------------------------------------------------------------\r\n");

	return (Status);
}

/******************************************************************************
* This function is the hook which will be called  before the FSBL does a handoff
* to the application. The user can add all the customized code required to be
* executed before the handoff to this routine.
*
* @param None
*
* @return
*		- XST_SUCCESS to indicate success
*		- XST_FAILURE.to indicate failure
*
****************************************************************************/
u32 TE_FsblHookBeforeHandoff_Custom(void)
{
	u32 Status;
	u8 RegVal, PARTID, REVID, SEQID;
	Status = XST_SUCCESS;

    xil_printf("\r\n--------------------------------------------------------------------------------\r\n");
    xil_printf("TE0722 TE_FsblHookBeforeHandoff_Custom\r\n"); 
	/* Add the code here */
    /* Init IIC*/
    	Status= iic_init();
    	if (Status != XST_SUCCESS) {
    	 xil_printf("Error:I2C initialization\r\n");
    	 goto END;
    	}

    	//grenn LED on MIO7

    	//mio 7 0x00000080
    	//      0xFFFFFF7F
    	//MIO7 direction out
    	Xil_Out32(XPS_GPIO_BASEADDR+0x00000204,(Xil_In32(XPS_GPIO_BASEADDR+0x00000204) | 0x00000080)) ;
    	//MIO7 out enable
    	Xil_Out32(XPS_GPIO_BASEADDR+0x00000208,(Xil_In32(XPS_GPIO_BASEADDR+0x00000208) | 0x00000080)) ;

    uint idx = 10;
	   for( idx = 10; idx > 0; idx = idx - 1 ){

    	xil_printf("\r\n \r\n  Read LIGHT SENSOR ID: ");


    	Status= iic_read8(0x5A,0x0,&RegVal);
    	if (Status != XST_SUCCESS) {
    	 xil_printf("\r\nError:I2C Si1143 access\r\n");
    	 goto END;
    	}

    	PARTID=RegVal;
    	Status= iic_read8(0x5A,0x1,&RegVal);
    	REVID=RegVal;
    	Status= iic_read8(0x5A,0x2,&RegVal);
    	SEQID=RegVal;
    	if((PARTID & 0xFC)==0x40) {
    		xil_printf("Si114%x",(PARTID & 0x03));
    	} else {
    		xil_printf("Unknown PARTID 0x%x", PARTID);
    	}
    	xil_printf(" Revision: %x",REVID);
    	xil_printf(" Sequencer Revision: ");
    	if(SEQID==0x01) {
    		xil_printf("A01");
    	} else if(SEQID==0x02) {
    		xil_printf("A02");
    	} else if(SEQID==0x03) {
    		xil_printf("A03");
    	} else if(SEQID==0x08) {
    		xil_printf("A10");
    	} else if(SEQID==0x09) {
    		xil_printf("A11");
    	} else {
    		xil_printf(" Unknown ID 0x%x", SEQID);
    	}


    	//MIO7 out 1

    	Xil_Out32(XPS_GPIO_BASEADDR+0x00000040,(Xil_In32(XPS_GPIO_BASEADDR+0x00000040) | 0x00000080)) ;
    	xil_printf("\r\n LED D4 on (Remaining Loops 0x%x)", idx);
    	sleep(2);
    	//MIO7 out 0
    	Xil_Out32(XPS_GPIO_BASEADDR+0x00000040,(Xil_In32(XPS_GPIO_BASEADDR+0x00000040) & 0xFFFFFF7F)) ;
    	xil_printf("\r LED D4 off (Remaining Loops 0x%x)", idx);
    	sleep(2);
	   }
	   xil_printf("\r\n Loop finished...");

    xil_printf("\r\n--------------------------------------------------------------------------------\r\n");
  END:
	return (Status);
}


/******************************************************************************
* This function is the hook which will be called in case FSBL fall back
*
* @param None
*
* @return None
*
****************************************************************************/
void TE_FsblHookFallback_Custom(void)
{
  
    xil_printf("\r\n--------------------------------------------------------------------------------\r\n");
    xil_printf("TE0722 TE_FsblHookFallback_Custom\r\n"); 
	/* Add the code here */
    xil_printf("\r\n--------------------------------------------------------------------------------\r\n");
  
  
	//while(1);
}


